Send_ExtendedIM_IME_Off:
	If (Is_GoTo = 0)
	{
		sc_key := A_ThisHotkey

		GetKeyState, CapsLockState, CapsLock, T
		If (CapsLockState = "D")
		{
			Is_GoTo = 1
			Goto, Send_ExtendedIMShift_IME_Off
		}
		else
		{
			Is_GoTo = 0
		}
	}
	else
	{
		Is_GoTo = 0
	}


	Send,% (Layout = 3) ? QWERTY_%sc_key%
		: (Layout = 4) ? QWERTY_%sc_key%
		: (Layout = 5) ? Colemak_%sc_key%
		: (Layout = 6) ? User_%sc_key%
		: Dvorak_%sc_key%
return



Send_ExtendedIMShift_IME_Off:
	If (Is_GoTo = 0)
	{
		IfInString, A_ThisHotkey, +
		{
			StringTrimLeft, sc_key, A_ThisHotkey, 1
		}
		else
		IfInString, A_ThisHotkey, &
		{
			StringTrimLeft, sc_key, A_ThisHotkey, 8
		}


		GetKeyState, CapsLockState, CapsLock, T
		If (CapsLockState = "D")
		{
			Is_GoTo = 1
			Goto, Send_ExtendedIM_IME_Off
		}
		else
		{
			Is_GoTo = 0
		}
	}
	else
	{
		Is_GoTo = 0
	}


	Send,% (Layout = 3) ? QWERTY_shift_%sc_key%
		: (Layout = 4) ? QWERTY_shift_%sc_key%
		: (Layout = 5) ? Colemak_shift_%sc_key%
		: (Layout = 6) ? User_shift_%sc_key%
		: Dvorak_shift_%sc_key%
return


Send_ExtendedIM_IME_On:
	If (Is_GoTo = 0)
	{
		sc_key := A_ThisHotkey
		prior_sc_key := A_PriorHotkey


		GetKeyState, CapsLockState, CapsLock, T
		If (CapsLockState = "D")
		{
			Is_GoTo = 1
			Goto, Send_ExtendedIMShift_IME_Off
		}
		else
		{
			Is_GoTo = 0
		}
	}
	else
	{
		Is_GoTo = 0
	}



	; IME ̕ϊ\ĂƂ
	If (IME_IsConverting = 1)
	{
		Send,{%A_ThisHotkey%}
	}
	else
	{
		IfLess, IME_ConvMode, 16 ; ȓ͗p
		{
			Send,{%sc_key%}
		}
		else
		{
			this_key :=  (Layout = 3) ? QWERTY_%sc_key%
				: (Layout = 4) ? QWERTY_%sc_key%
				: (Layout = 5) ? Colemak_%sc_key%
				: (Layout = 6) ? User_%sc_key%
				: Dvorak_%sc_key%


			If sc_key not contains *
			{
				StringTrimRight, Dvorak_key, Dvorak_%sc_key%, 0
			}
			else
			{
				Dvorak_key = 
			}

			If prior_sc_key contains ~,*,^,#,!
			{
				Prior_Dvorak_key =
			}
			else
			If prior_sc_key contains  +,&
			{
				IfInString, prior_sc_key, +
				{
					StringTrimLeft, Prior_Dvorak_key, prior_sc_key, 1
				}
				else
				IfInString, prior_sc_key, &
				{
					StringTrimLeft, Prior_Dvorak_key, prior_sc_key, 8
				}


				StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
			}
			else
			{
				StringTrimRight, Prior_Dvorak_key, Dvorak_%prior_sc_key%, 0
			}


			If (Which_Japanese_Layout = 2)
			{
				if Dvorak_key in ,,,`',.,`;,q,j,k,x,a,o,e,u,i
				{
					SendDvorakJP_Vowel(Dvorak_key, Prior_Dvorak_key)
				}
				else
				if Dvorak_key in p,y,f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendDvorakJP_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					Send,%this_key%
				}
			}
			else
			If (Which_Japanese_Layout = 3)
			{
				if Dvorak_key in c,`;,q,j,k,x
				{
					SendDvorakY(Dvorak_key)
				}
				else
				{
					Send,%this_key%
				}
			}
			else
			If (Which_Japanese_Layout = 4)
			{
				if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
				{
					SendACT09_Vowel(Dvorak_key, Prior_Dvorak_key)
				}
				else
				if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendACT09_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					Send,%this_key%
				}
			}
			else
			If (Which_Japanese_Layout = 5)
			{
				SendSousei_Normal(Dvorak_key, Prior_Dvorak_key)
			}
			else
			If (Which_Japanese_Layout = 6)
			{
				if Dvorak_key in ,,,`',.,p,y,a,o,e,u,i,`;,q,j,k,x
				{
					SendJLOD_Vowel(Dvorak_key, Prior_Dvorak_key)
				}
				else
				if Dvorak_key in f,g,c,r,l,d,h,t,n,s,b,m,w,v,z
				{
					SendJLOD_Consonant(Dvorak_key, Prior_Dvorak_key)
				}
				else
				{
					; Dvorak z -  Enter Ƃ
					If (Is_Hyphen_to_Enter = 1 && sc_key = "sc028")
					{
						this_key = {Enter}
					}

					Send,%this_key%
				}
			}
			else
			If (Which_Japanese_Layout = 7) ; ʔz
			{
				if (sc_key = "SC010")
					onKeyDown("_Q")
				else
				if (sc_key = "SC011")
					onKeyDown("_W")
				else
				if (sc_key = "SC012")
					onKeyDown("_E")
				else
				if (sc_key = "SC013")
					onKeyDown("_R")
				else
				if (sc_key = "SC014")
					onKeyDown("_T")
				else
				if (sc_key = "SC015")
					onKeyDown("_Y")
				else
				if (sc_key = "SC016")
					onKeyDown("_U")
				else
				if (sc_key = "SC017")
					onKeyDown("_I")
				else
				if (sc_key = "SC018")
					onKeyDown("_O")
				else
				if (sc_key = "SC019")
					onKeyDown("_P")
				else
				if (sc_key = "SC01A")
					onKeyDown("_AT")
				else
				if (sc_key = "SC01E")
					onKeyDown("_A")
				else
				if (sc_key = "SC01F")
					onKeyDown("_S")
				else
				if (sc_key = "SC020")
					onKeyDown("_D")
				else
				if (sc_key = "SC021")
					onKeyDown("_F")
				else
				if (sc_key = "SC022")
					onKeyDown("_G")
				else
				if (sc_key = "SC023")
					onKeyDown("_H")
				else
				if (sc_key = "SC024")
					onKeyDown("_J")
				else
				if (sc_key = "SC025")
					onKeyDown("_K")
				else
				if (sc_key = "SC026")
					onKeyDown("_L")
				else
				if (sc_key = "SC027")
					onKeyDown("_SColon")
				else
				if (sc_key = "SC028")
					Send,{BS}
				else
				if (sc_key = "SC02C")
					onKeyDown("_Z")
				else
				if (sc_key = "SC02D")
					onKeyDown("_X")
				else
				if (sc_key = "SC02E")
					onKeyDown("_C")
				else
				if (sc_key = "SC02F")
					onKeyDown("_V")
				else
				if (sc_key = "SC030")
					onKeyDown("_B")
				else
				if (sc_key = "SC031")
					onKeyDown("_N")
				else
				if (sc_key = "SC032")
					onKeyDown("_M")
				else
				if (sc_key = "SC033")
					onKeyDown("_Comma")
				else
				if (sc_key = "SC034")
					onKeyDown("_Dot")
				else
				if (sc_key = "SC035")
					onKeyDown("_Slash")
				else
					Send,%this_key%
			}
			else
			if Which_Japanese_Layout in 8,9 ; h艺ʔzƍh艺ʔz
			{
				if (sc_key = "SC00C")
					Send,^v
				else
				if (sc_key = "SC00D")
					Send,{ESC}
				else
				if (sc_key = "SC07D")
					Send,{DEL}
				else
				if (sc_key = "SC010")
					onKeyDown("_Q")
				else
				if (sc_key = "SC011")
					onKeyDown("_W")
				else
				if (sc_key = "SC012")
					onKeyDown("_E")
				else
				if (sc_key = "SC013")
					onKeyDown("_R")
				else
				if (sc_key = "SC014")
					onKeyDown("_T")
				else
				if (sc_key = "SC015")
					onKeyDown("_Y")
				else
				if (sc_key = "SC016")
					onKeyDown("_U")
				else
				if (sc_key = "SC017")
					onKeyDown("_I")
				else
				if (sc_key = "SC018")
					onKeyDown("_O")
				else
				if (sc_key = "SC019")
					onKeyDown("_P")
				else
				if (sc_key = "SC01A")
					onKeyDown("_AT")
				else
				if (sc_key = "SC01B")
					onKeyDown("_LBrace")
				else
				if (sc_key = "SC01E")
					onKeyDown("_A")
				else
				if (sc_key = "SC01F")
					onKeyDown("_S")
				else
				if (sc_key = "SC020")
					onKeyDown("_D")
				else
				if (sc_key = "SC021")
					onKeyDown("_F")
				else
				if (sc_key = "SC022")
					onKeyDown("_G")
				else
				if (sc_key = "SC023")
					onKeyDown("_H")
				else
				if (sc_key = "SC024")
					onKeyDown("_J")
				else
				if (sc_key = "SC025")
					onKeyDown("_K")
				else
				if (sc_key = "SC026")
					onKeyDown("_L")
				else
				if (sc_key = "SC027")
					onKeyDown("_SColon")
				else
				if (sc_key = "SC028")
					onKeyDown("_Colon")
				else
				if (sc_key = "SC02B")
					onKeyDown("_RBrace")
				else
				if (sc_key = "SC02C")
					onKeyDown("_Z")
				else
				if (sc_key = "SC02D")
					onKeyDown("_X")
				else
				if (sc_key = "SC02E")
					onKeyDown("_C")
				else
				if (sc_key = "SC02F")
					onKeyDown("_V")
				else
				if (sc_key = "SC030")
					onKeyDown("_B")
				else
				if (sc_key = "SC031")
					onKeyDown("_N")
				else
				if (sc_key = "SC032")
					onKeyDown("_M")
				else
				if (sc_key = "SC033")
					onKeyDown("_Comma")
				else
				if (sc_key = "SC034")
					onKeyDown("_Dot")
				else
				if (sc_key = "SC035")
					onKeyDown("_Slash")
				else
				if (sc_key = "SC073")
					onKeyDown("_BackSlash")
				else
					Send,%this_key%
			}
			else
			If (Which_Japanese_Layout = 1)0
			{
				SendMurakumo(sc_key)
			}
			else
			{
				IfEqual, Special_extension, 1
				{
					SendSpecial_Key(this_key)
				}
				else
				{
					Send,%this_key%
				}
			}
		}
	}
return





Send_ExtendedIMShift_IME_On:
	If (Is_GoTo = 0)
	{
		IfInString, A_ThisHotkey, +
		{
			StringTrimLeft, sc_key, A_ThisHotkey, 1
		}
		else
		IfInString, A_ThisHotkey, &
		{
			StringTrimLeft, sc_key, A_ThisHotkey, 8
		}

		IfInString, A_PriorHotkey, +
		{
			StringTrimLeft, prior_sc_key, A_PriorHotkey, 1
		}
		else
		IfInString, A_PriorHotkey, &
		{
			StringTrimLeft, prior_sc_key, A_PriorHotkey, 8
		}


		GetKeyState, CapsLockState, CapsLock, T
		If (CapsLockState = "D")
		{
			Is_GoTo = 1
			Goto, Send_ExtendedIM_IME_Off
		}
		else
		{
			Is_GoTo = 0
		}
	}
	else
	{
		Is_GoTo = 0
	}



	StringTrimRight, Dvorak_key, Dvorak_shift_%sc_key%, 0


	IfLess, IME_ConvMode, 16 ; ȓ͗p
	{
		Send,+{%sc_key%}
	}
	else
	If (Which_Japanese_Layout = 5)
	{
		If prior_sc_key contains ~,*,^,#
		{
			Prior_Dvorak_key = 
		}
		else
		If prior_sc_key contains +,&
		{
			IfInString, prior_sc_key, +
			{
				StringTrimLeft, Prior_Dvorak_key, prior_sc_key, 1
			}
			else
			IfInString, prior_sc_key, &
			{
				StringTrimLeft, Prior_Dvorak_key, prior_sc_key, 8
			}


			StringTrimRight, Prior_Dvorak_key, Dvorak_shift_%Prior_Dvorak_key%, 0
		}
		else
		{
			StringTrimRight, Prior_Dvorak_key, Dvorak_%prior_sc_key%, 0
		}


		SendSouseiShift(Dvorak_key, Prior_Dvorak_key)
	}
	else
	{
		If (Is_Shift_plus_Alphabet = 1)
		{
			If sc_key contains 010,011,012,013,014,015,016,017,018,019,01E,01F,020,021,022,023,024,025,026,027,02C,02D,02E,02F,030,031,032,033,034,035
			{
				IME_SET(0)
				GoTo, Send_ExtendedIMShift_IME_Off
			}
			else
			{
				Send,% (Layout = 3) ? QWERTY_shift_%sc_key%
					: (Layout = 4) ? QWERTY_shift_%sc_key%
					: (Layout = 5) ? Colemak_shift_%sc_key%
					: (Layout = 6) ? User_shift_%sc_key%
					: Dvorak_shift_%sc_key%
			}
		}
		else
		{
			Send,% (Layout = 3) ? QWERTY_shift_%sc_key%
				: (Layout = 4) ? QWERTY_shift_%sc_key%
				: (Layout = 5) ? Colemak_shift_%sc_key%
				: (Layout = 6) ? User_shift_%sc_key%
				: Dvorak_shift_%sc_key%
		}
	}
return
